﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {

        private static Infragistics.Win.Appearance activeAppearance;
        private static Infragistics.Win.Appearance inactiveAppearance;

        private DataTable dt;

        public Form1()
        {
            InitializeComponent();

            activeAppearance = new Infragistics.Win.Appearance();
            activeAppearance.BackColor = Color.Green;
            activeAppearance.BackColor2 = Color.LimeGreen;
            activeAppearance.BackGradientStyle = GradientStyle.GlassTop37Bright;

            inactiveAppearance = new Infragistics.Win.Appearance();
            inactiveAppearance.BackColor = Color.Ivory;

        }


        private void Form1_Load(object sender, EventArgs e)
        {
            string[] weekDays = { "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday" };
            int defaultHourSize = 60;
            int partCountbyHour = 2;
            int hourOffset = 6;
            int hourCount = 14;
            dt = new DataTable();
            dt.Columns.Add("Day");
            for (int i = partCountbyHour * hourOffset; i < partCountbyHour * (hourCount + hourOffset); i++)
            {
                dt.Columns.Add(i.ToString(), typeof(bool)).DefaultValue = false;
            }
            DataRow dr;
            for (int i = 0; i < weekDays.Length; i++)
            {
                dr = dt.NewRow();
                dr["Day"] = weekDays[i];
                dt.Rows.Add(dr);
            }
            this.ultraGrid1.DisplayLayout.Override.DefaultColWidth = (int)defaultHourSize / partCountbyHour;
            this.ultraGrid1.DataSource = dt;


            this.ultraGrid1.DisplayLayout.Bands[0].UseRowLayout = true;

            UltraGridColumn column;
            column = this.ultraGrid1.DisplayLayout.Bands[0].Columns[0];
            column.RowLayoutColumnInfo.LabelPosition = LabelPosition.Default;
            column.RowLayoutColumnInfo.OriginX = 0;
            column.RowLayoutColumnInfo.OriginY = 0;
            column.RowLayoutColumnInfo.SpanX = 1;
            column.RowLayoutColumnInfo.SpanY = 2;

            for (int i = partCountbyHour * hourOffset; i < partCountbyHour * (hourCount + hourOffset); i++)
            {
                column = this.ultraGrid1.DisplayLayout.Bands[0].Columns[i.ToString()];
                column.RowLayoutColumnInfo.LabelPosition = LabelPosition.None;
                column.RowLayoutColumnInfo.OriginX = i + 1;
                column.RowLayoutColumnInfo.OriginY = 1;
                column.RowLayoutColumnInfo.SpanX = 1;
                column.RowLayoutColumnInfo.SpanY = 1;
                column.EditorControl = this.ultraCheckEditor2;
            }
            for (int i = hourOffset; i < hourCount + hourOffset; i++)
            {
                column = this.ultraGrid1.DisplayLayout.Bands[0].Columns.Add(i.ToString() + "h");
                column.RowLayoutColumnInfo.LabelPosition = Infragistics.Win.UltraWinGrid.LabelPosition.LabelOnly;
                column.RowLayoutColumnInfo.OriginX = i * partCountbyHour + 1;
                column.RowLayoutColumnInfo.OriginY = 0;
                column.RowLayoutColumnInfo.SpanX = partCountbyHour;
                column.RowLayoutColumnInfo.SpanY = 1;
                column.Header.Appearance.TextHAlign = HAlign.Left;
            }


            this.ultraGrid1.DisplayLayout.Bands[0].Columns[0].PerformAutoResize();
            this.ultraGrid1.DisplayLayout.Bands[0].Columns[0].Width += 10;
            this.ultraGrid1.DrawFilter = new NoFocusRectDrawFilter();

        }

 
        private class NoFocusRectDrawFilter : IUIElementDrawFilter
        {
            #region Implementation of IUIElementDrawFilter
            public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
            {
                return true;
            }
            public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
            {
                return Infragistics.Win.DrawPhase.BeforeDrawFocus;                
            }
            #endregion
        }

        private void ultraGrid1_AfterCellActivate(object sender, EventArgs e)
        {
            if (((UltraGrid)sender).ActiveCell.Value is bool)
            {
                UltraGridCell cell = ((UltraGrid)sender).ActiveCell;
                cell.Value = !(bool)cell.Value;
            }
        }


    }
}
